#include <AccelStepper.h>

// TB6612 pin definitions
#define AIN1 6
#define AIN2 7
#define BIN1 1
#define BIN2 2
#define PWMA 29
#define PWMB 0
#define STBY 3

// Motion sensor pin
#define PIR_PIN 4

// Set up the stepper as a full 2-pin driver using both H-bridges
AccelStepper stepper(AccelStepper::FULL4WIRE, AIN1, AIN2, BIN1, BIN2);

void setup() {
  // Motor control pins
  pinMode(AIN1, OUTPUT);
  pinMode(AIN2, OUTPUT);
  pinMode(BIN1, OUTPUT);
  pinMode(BIN2, OUTPUT);
  pinMode(PWMA, OUTPUT);
  pinMode(PWMB, OUTPUT);
  pinMode(STBY, OUTPUT);
  
  // Motion sensor
  pinMode(PIR_PIN, INPUT);

  // Enable motor driver
  digitalWrite(STBY, HIGH);
  analogWrite(PWMA, 255); // Full speed
  analogWrite(PWMB, 255); // Full speed

  // Stepper settings
  stepper.setMaxSpeed(200);
  stepper.setAcceleration(100);
}

void loop() {
  int motion = digitalRead(PIR_PIN);

  if (motion == HIGH) {
    // Move one revolution (adjust steps per rev if needed)
    stepper.moveTo(stepper.currentPosition() + 200);
  }

  stepper.run(); // Non-blocking stepper control
}